#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

typedef long long ll;

using namespace std;

const int MAXN = 100;
const int MAXX = 1e9;
int cur_test = -1;


string itoa(int x) 
{
    stringstream ss;           
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<int> a) 
{
    startTest(cur_test++);
    cout << a.size() << endl;
    for (int i = 0; i < (int)a.size(); i++)
        cout << a[i] << ((i == (int)a.size() - 1) ? "\n" : " ");
}

void gen_rand(int n, int maxx)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = rnd.next(maxx) + 1;
    }
    write_test(a);  
}

void gen_rand_odd(int n, int maxx, int k = 0)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = rnd.next(maxx / 2) * 2 + 1;
    }
    for (int i = 0; i < k; i++)
        a[rnd.next(n)] = rnd.next(maxx) + 1;
    write_test(a);  
}

void gen_rand_even(int n, int maxx, int k = 0)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = rnd.next(maxx / 2) * 2 + 2;
    }
    for (int i = 0; i < k; i++)
        a[rnd.next(n)] = rnd.next(maxx) + 1;
    write_test(a);  
}

void gen_max_ans(int n)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = i + 1;
    }
    int k = 0;
    for (int i = 1; i < n; i++)
    {
        k += rnd.next(5) * 2;
        a[i] += k;
    }
    shuffle(a.begin(), a.end());
    write_test(a);  
}

void gen_max_ans1(int n)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = i + 2;
    }
    int k = 0;
    for (int i = 1; i < n; i++)
    {
        k += rnd.next(5) * 2;
        a[i] += k;
    }
    shuffle(a.begin(), a.end());
    write_test(a);  
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    gen_rand(10, 10);
    gen_rand_even(10, 10);
    gen_rand_odd(10, 10);
    gen_rand_even(10, 20, 3);
    gen_rand_odd(10, 20, 3);
    gen_max_ans(5);
    gen_max_ans1(5);

    for (int i = 20; i <= MAXN; i += 20)
    {
        int n;
        n = rnd.next(i / 2) + i / 2 + 1;
        gen_rand(n, MAXX);
        n = rnd.next(i / 2) + i / 2 + 1;
        gen_rand_even(n, MAXX, rnd.next(50));
        n = rnd.next(i / 2) + i / 2 + 1;
        gen_rand_odd(n, MAXX, rnd.next(50));
        
    }

    gen_rand(MAXN, MAXX);
    gen_rand_even(MAXN, MAXX);
    gen_rand_odd(MAXN, MAXX);
    gen_rand_even(MAXN, MAXX, 23);
    gen_rand_odd(MAXN, MAXX, 32);
    gen_max_ans(MAXN);
    gen_max_ans1(MAXN);


    return 0;
}

