#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MOD = 786433;
const int BASE = 17;
const int N = 1 << BASE;
const int ROOT = 25;

int bin(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) res = 1LL * res * a % MOD;
        a = 1LL * a * a % MOD;
        n >>= 1;
    }
    return res;
}

int inv(int x) {
    return bin(x, MOD - 2);
}

int rev[N], root[N];
void init() {
    for (int i = 1; i < N; i++) rev[i] = (rev[i >> 1] >> 1) | ((i & 1) << (BASE - 1)); 
    int NN = N >> 1;
    int z = 1;
    for (int i = 0; i < NN; i++) {
        root[NN + i] = z;
        z = 1LL * z * ROOT % MOD;
    }
    for (int i = NN - 1; i > 0; i--) root[i] = root[i * 2];
}

void fft(int *a, int *f) {
    for (int i = 0; i < N; i++) f[i] = a[rev[i]];
    for (int k = 1; k < N; k <<= 1) for (int i = 0; i < N; i += 2 * k) for (int j = 0; j < k; j++) {
        int z = f[i + j + k] * 1LL * root[k + j] % MOD;
        f[i + j + k] = (f[i + j] - z + MOD) % MOD;
        f[i + j] = (f[i + j] + z) % MOD;
    }
}

const int T = 50100;
int A[N], B[N], C[N], F[N], G[N];
vector<int> mul(vector<int> a, vector<int> b) {
    for (int i = 0; i < T; i++) {
        A[i] = a[i];
        B[i] = b[i];
    }
    fft(A, F);
    fft(B, G);
    int on = inv(N);
    for (int i = 0; i < N; i++) F[i] = 1LL * F[i] * G[i] % MOD * on % MOD;
    reverse(F + 1, F + N);
    fft(F, C);
    vector<int> c(T);
    for (int i = 0; i < T; i++) {
        c[i] = C[i];
    }
    return c;
}

vector<int> bin(vector<int> a, int n) {
    vector<int> res(T, 0);
    res[0] = 1;
    while (n) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

int main() {
    init();
    int n, k, q;
    scanf("%d%d%d", &n, &k, &q);
    vector<int> cnt(T);
    for (int i = 0; i < n; i++) {
        int x;
        scanf("%d", &x);
        cnt[x]++;
    }
    cnt = bin(cnt, k);
    vector<int> sum(T + 1);
    for (int i = 1; i <= T; i++) sum[i] = (sum[i - 1] + cnt[i - 1]) % MOD;

    for (int i = 0; i < q; i++) {
        int l, r;
        scanf("%d%d", &l, &r);
        printf("%d\n", (sum[r + 1] - sum[l] + MOD) % MOD);
    }
}
