import random
import math
random.seed("basic02/teleportgun")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2, 3], [1, 2, 3])
        self.print_test([1, 4, 3, 6], [8, 1, 1])

    def generate_min_tests(self):
        self.print_test([1], [1])
        self.print_test([1], [10**4])
        self.print_test([10**4], [1])
        self.print_test([239], [8239])
        self.print_test([1, 2, 1], [2, 1, 2])
        
    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxm, maxv):
        a = [random.randint(1, maxv) for _ in range(maxn)]
        b = [random.randint(1, maxv) for _ in range(maxm)]
        self.print_test(a, b)

    def generate_max_tests(self, maxn, maxv):
        self.print_test([1] * maxn, [1] * maxn)
        self.print_test([maxv] * maxn, [maxv] * maxn)
        self.print_test([1] * maxn, [maxv] * maxn)
        a = [(i % maxv + 1) for i in range(maxn)]
        b = []
        cur = maxv
        for i in range(maxn):
            b.append(cur)
            cur -= 1
            if cur == 0:
                cur = maxv
        self.print_test(a, b)
        random.shuffle(b)
        self.print_test(a, b)

    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(a), file=test_file)
        print(' '.join(map(str, a)), file=test_file)
        print(len(b), file=test_file)
        print(' '.join(map(str, b)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [10, 100, 10**3, 10**5]
        maxvs = [10, 10**3, 10**4]
        for n in ns:
            for m in ns:
                for maxv in maxvs:
                    self.generate_random_test(n, m, maxv)
        self.generate_max_tests(10**5, 10**4)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
