import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class sequences_ez {

    private BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    private StringTokenizer tokenizer;

    private int nextInt() throws Exception {
        if (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(tokenizer.nextToken());
    }

    public static void main(String[] args) throws Exception {
        new sequences_ez().run();
    }

    private void run() throws Exception {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        int[][] lis = new int[n][n];
        for (int left = 0; left < n; left++) {
            for (int right = left; right < n; right++) {
                lis[left][right] = 1;
                for (int k = left; k < right; k++) {
                    if (a[k] < a[right]) {
                        lis[left][right] = Math.max(lis[left][right], lis[left][k] + 1);
                    }
                }
            }
        }

        StringBuilder sb = new StringBuilder();
        for (int k = 0; k < n; ++k) {
            int[] ans = new int[n];
            for (int left = 0; left < n; ++left) {
                for (int right = left; right < n; ++right) {
                    if (lis[left][right] >= k + 1) {
                        ans[right] = Math.max(ans[right], (left == 0 ? 0 : ans[left - 1]) + lis[left][right]);
                    }
                }
            }
            sb.append(ans[n - 1]).append(' ');
        }
        System.out.println(sb);
    }

}
